# -*- coding:UTF-8 -*-
# @Time  : 2020/9/8 13:39
# @File  : spark_test.py
# @email : litao@igengmei.com
# @author : litao

# -*- coding:UTF-8 -*-
# @Time  : 2020/9/4 17:07
# @File  : search_meigou_ctr.py
# @email : litao@igengmei.com
# @author : litao

import hashlib
import json

import pymysql
import xlwt, datetime
import redis
# from pyhive import hive
from maintenance.func_send_email_with_file import send_file_email
from typing import Dict, List
from elasticsearch_7 import Elasticsearch
from elasticsearch_7.helpers import scan
import sys
import time
from pyspark import SparkConf
from pyspark.sql import SparkSession, DataFrame


# from pyspark.sql.functions import lit
# import pytispark.pytispark as pti
from elasticsearch import Elasticsearch

exists_es_dic = {}
es = Elasticsearch([
    {
        'host': '172.16.31.17',
        'port': 9200,
    }, {
        'host': '172.16.31.11',
        'port': 9200,
    }])

def con_sql(sql):
    # 从数据库的表里获取数据

    db = pymysql.connect(host='172.16.40.158', port=4000, user='st_user', passwd='aqpuBLYzEV7tML5RPsN1pntUzFy',
                         db='jerry_prod')
    cursor = db.cursor()
    cursor.execute(sql)
    result = cursor.fetchall()
    db.close()
    return result


startTime = time.time()
sparkConf = SparkConf()
sparkConf.set("spark.sql.crossJoin.enabled", True)
sparkConf.set("spark.debug.maxToStringFields", "100")
sparkConf.set("spark.tispark.plan.allow_index_double_read", False)
sparkConf.set("spark.tispark.plan.allow_index_read", True)
sparkConf.set("spark.hive.mapred.supports.subdirectories", True)
sparkConf.set("spark.hadoop.mapreduce.input.fileinputformat.input.dir.recursive", True)
sparkConf.set("spark.serializer", "org.apache.spark.serializer.KryoSerializer")
sparkConf.set("mapreduce.output.fileoutputformat.compress", False)
sparkConf.set("mapreduce.map.output.compress", False)
sparkConf.set("prod.gold.jdbcuri",
              "jdbc:mysql://172.16.30.136/doris_prod?user=doris&password=o5gbA27hXHHm&rewriteBatchedStatements=true")
sparkConf.set("prod.mimas.jdbcuri",
              "jdbc:mysql://172.16.30.138/mimas_prod?user=mimas&password=GJL3UJe1Ck9ggL6aKnZCq4cRvM&rewriteBatchedStatements=true")
sparkConf.set("prod.gaia.jdbcuri",
              "jdbc:mysql://172.16.30.143/zhengxing?user=work&password=BJQaT9VzDcuPBqkd&rewriteBatchedStatements=true")
sparkConf.set("prod.tidb.jdbcuri",
              "jdbc:mysql://172.16.40.158:4000/eagle?user=st_user&password=aqpuBLYzEV7tML5RPsN1pntUzFy&rewriteBatchedStatements=true")
sparkConf.set("prod.jerry.jdbcuri",
              "jdbc:mysql://172.16.40.158:4000/jerry_prod?user=st_user&password=aqpuBLYzEV7tML5RPsN1pntUzFy&rewriteBatchedStatements=true")
sparkConf.set("prod.tispark.pd.addresses", "172.16.40.158:2379")
sparkConf.set("prod.tispark.pd.addresses", "172.16.40.170:4000")
sparkConf.set("prod.tidb.database", "jerry_prod")
sparkConf.setAppName("test")

spark = (SparkSession.builder.config(conf=sparkConf).config("spark.sql.extensions", "org.apache.spark.sql.TiExtensions")
         .config("spark.tispark.pd.addresses", "172.16.40.170:2379").enableHiveSupport().getOrCreate())

spark.sql("ADD JAR hdfs:///user/hive/share/lib/udf/brickhouse-0.7.1-SNAPSHOT.jar")
spark.sql("ADD JAR hdfs:///user/hive/share/lib/udf/hive-udf-1.0-SNAPSHOT.jar")
spark.sql("CREATE TEMPORARY FUNCTION json_map AS 'brickhouse.udf.json.JsonMapUDF'")
spark.sql("CREATE TEMPORARY FUNCTION is_json AS 'com.gmei.hive.common.udf.UDFJsonFormatCheck'")
spark.sql("CREATE TEMPORARY FUNCTION arrayMerge AS 'com.gmei.hive.common.udf.UDFArryMerge'")


# print(huidu_device_id_sql)
# huidu_device_id_df = spark.sql(huidu_device_id_sql)
# huidu_device_id_df.createOrReplaceTempView("dev_view")
sql_search_ctr = r"""
SELECT query,search_pv,search_uv
	FROM
	(
		SELECT query
				,count(t1.cl_id) as search_pv
				,count(distinct t1.cl_id) as search_uv
		FROM
		(
			SELECT partition_date
					,params['query'] as query
					,cl_id
			FROM online.bl_hdfs_maidian_updates
			WHERE partition_date >= {start_date} 
            AND partition_date < {end_date}
			AND ((action = 'do_search' AND params['input_type']<>'everyone_watch') or action='search_result_click_search')

			UNION ALL
            SELECT partition_date,params['query'] as query,cl_id
            FROM online.bl_hdfs_maidian_updates
            WHERE partition_date >= {start_date} 
          	AND partition_date < {end_date}
          	AND action = 'do_search'
            and params['input_type']='everyone_watch'
            and params['tab']='精选'
            and page_name='home'
            AND params['query'] not in ('AI测颜值','AI测肤质')  --这两个词不跳转搜索结果页 

			UNION ALL
            SELECT partition_date,params['query'] as query,cl_id
            FROM online.bl_hdfs_maidian_updates
            WHERE partition_date >= {start_date} 
          	AND partition_date < {end_date}
          	AND action = 'on_click_card'
          	AND params['page_name']='search_home'


			UNION ALL
			SELECT partition_date
					,params['card_name'] as query
					,cl_id
			FROM online.bl_hdfs_maidian_updates
			WHERE partition_date >= {start_date} 
            AND partition_date < {end_date}
			AND action = 'on_click_card'
			AND params['in_page_pos']='猜你喜欢'
			--AND params['tab_name']='精选'
			AND params['card_type']='search_word'
			AND params['card_name'] not in ('AI测颜值','AI测肤质')  --这两个词不跳转搜索结果页 
			--AND page_name='home' android的page_name为空

			UNION ALL
			SELECT partition_date
					,params['card_name'] as query
					,cl_id
			FROM online.bl_hdfs_maidian_updates
			WHERE partition_date >= {start_date} 
            AND partition_date < {end_date}
			AND action = 'on_click_card'
			AND page_name='welfare_home'
			AND params['card_type'] ='search_word'
			AND params['in_page_pos']='大家都在搜'

			UNION ALL
			SELECT partition_date
					,params['card_name'] as query
					,cl_id
			FROM online.bl_hdfs_maidian_updates
			WHERE partition_date >= {start_date} 
            AND partition_date < {end_date}
			AND int(split(app_version,'\\.')[1]) >= 27
			AND action='on_click_card'
			AND params['card_type']='highlight_word'
		)t1
		JOIN
		(
			SELECT partition_date,device_id,t2.active_type,t2.channel,t2.device_os_type
            FROM
            (
                SELECT
                partition_date,m.device_id
                ,array(device_os_type ,'合计') as device_os_type
                ,array(case WHEN active_type = '4'  THEN '老活' 
                      WHEN active_type  in ('1','2')  then '新增' END ,'合计') as active_type 
                ,array(CASE WHEN is_ai_channel = 'true' THEN 'AI'  ELSE '其他' END , '合计') as channel
                FROM online.ml_device_day_active_status m
                	LEFT JOIN 
	                (SELECT code,is_ai_channel,partition_day
	                 FROM DIM.DIM_AI_CHANNEL_ZP_NEW
	                 WHERE partition_day>= {start_date}  
	                 AND partition_day < {end_date}) tmp
	                ON  m.partition_date=tmp.partition_day AND first_channel_source_type=code
                WHERE partition_date >= {start_date} 
            	AND partition_date < {end_date}
                AND active_type in ('1','2','4')
            ) mas
            LATERAL VIEW explode(mas.channel) t2 AS channel
            LATERAL VIEW explode(mas.device_os_type) t2 AS device_os_type
            LATERAL VIEW explode(mas.active_type) t2 AS active_type
		)t2
		on t1.cl_id=t2.device_id AND t1.partition_date = t2.partition_date
		GROUP BY query
		) order by search_pv desc limit 200
""".format(start_date='20201018',end_date='20201025')

print(sql_search_ctr)
search_ctr_df = spark.sql(sql_search_ctr)
# spam_pv_df.createOrReplaceTempView("dev_view")
search_ctr_df.show(1)
sql_res = search_ctr_df.collect()

print("-------------------------------")
for res in sql_res:
    print(res.query,res.search_pv)
    results = es.search(
        index='gm-dbmw-diary-read',
        doc_type='diary',
        timeout='10s',
        body=body
    )

